-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : top_tb.vhd
-- Revision : V0.1
-- Author :   Zdenk Sojka
-- Created :  16. 05. 2007
--
-- Modifications
-- 0.1	16. 05. 2007 by Zdenk Sojka
-----------------------------------------------------------------
-- zakladni testbench celeho pripravku
--
-- pouze pro posilani dat a overeni funkce
-- verze < 1.0 --> neni produkcni verze
--
-- 0.1	prvn verze
-----------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY top_tb_vhd IS
END top_tb_vhd;

ARCHITECTURE behavior OF top_tb_vhd IS 

--	constant iot : time := 0.5 us;	-- 1 mbit
--	constant iot : time := 4.34 us;	-- 115200 bps
	constant iot : time := 26.04 us;	-- 19200 bps
--	constant iot : time := 1.67 ms;	-- 300 bps
	

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT top
	PORT(
		rx : IN std_logic;
		clk : IN std_logic;
		rst : IN std_logic;          
		tx : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL rx :  std_logic := '1';
	SIGNAL clk :  std_logic := '0';
	SIGNAL rst :  std_logic := '0';

	--Outputs
	SIGNAL tx :  std_logic;
	shared variable poslat : std_logic_vector(7 downto 0);
	shared variable xposlat : std_logic_vector(10 downto 0);
	signal iclk : std_logic;
	
--	SIGNAL leds :  std_logic_vector(7 downto 0);

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: top PORT MAP(
		rx => rx,
		tx => tx,
--		leds => leds,
		clk => clk,
		rst => rst
	);

	iohod : process
	begin
		iclk <= '1';
		wait for iot;
		iclk <= '0';
		wait for iot;
	end process;

	hodiny : process
	begin
		clk <= '1';
		wait for 10ns;	-- pro 50 MHz hodiny
		clk <= '0';
		wait for 10ns;
	end process;

	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		rst <= '1';
		wait for 100 ns;
		rst <= '0';
		wait until ( clk'event ) and ( clk='1' );
		
		poslat := X"38";	-- 8
		
		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');

		poslat := X"31";	-- 1
		
		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');

		poslat := X"2A";	-- hvezdicka

		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');

		poslat := X"31";	-- cislo 1

		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');

		poslat := X"3D";	-- rovnitko

		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');

		wait for 3.5 ms;






		poslat := X"38";	-- cislo 8
		
		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');

		poslat := X"35";	-- cislo 5
		
		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');

		poslat := X"2A";	-- hvezdicka

		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');

		poslat := X"31";	-- cislo 1

		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');

		poslat := X"32";	-- cislo 2

		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');
		
		poslat := X"33";	-- cislo 3

		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');

		poslat := X"3D";	-- rovnitko

		xposlat := "11" & poslat & "0";
		for i in 0 to 10 loop
			wait until iclk'event and (iclk = '0');
			rx <= xposlat(i);
		end loop;
		wait until iclk'event and (iclk = '0');

		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
