-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : P1_bridge_tb.vhd
-- Revision : V2.0
-- Author :   Josef Nouzak
-- Created :  17. 05. 2007
--
-- Modifications
--
-- 
-- 
-----------------------------------------------------------------
-- test bench for this entity
--
-- 2.0	zmena dat dodelany asserty
-- 1.0
-----------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
USE ieee.std_logic_textio.ALL;
USE std.textio.ALL;
use ieee.std_logic_arith.all;


ENTITY P1_bridge_tb_vhd IS
END P1_bridge_tb_vhd;

ARCHITECTURE behavior OF P1_bridge_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT bridge
	PORT(
		data_rx : IN std_logic_vector(7 downto 0);
		act_uart : IN std_logic;
		rdy_uart : IN std_logic;
		valid : IN std_logic;
		vys : IN std_logic_vector(15 downto 0);
		clk : IN std_logic;
		rst : IN std_logic;          
		data_tx : OUT std_logic_vector(7 downto 0);
		data_mul : OUT std_logic_vector(7 downto 0);
		ack_uart : OUT std_logic;
		send_uart : OUT std_logic;
		btns : OUT std_logic_vector(1 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL act_uart :  std_logic := '0';
	SIGNAL rdy_uart :  std_logic := '0';
	SIGNAL valid :  std_logic := '0';
	SIGNAL clk :  std_logic := '0';
	SIGNAL rst :  std_logic := '0';
	SIGNAL data_rx :  std_logic_vector(7 downto 0) := (others=>'0');
	SIGNAL vys :  std_logic_vector(15 downto 0) := (others=>'0');

	--Outputs
	SIGNAL data_tx :  std_logic_vector(7 downto 0);
	SIGNAL data_mul :  std_logic_vector(7 downto 0);
	SIGNAL ack_uart :  std_logic;
	SIGNAL send_uart :  std_logic;
	SIGNAL btns :  std_logic_vector(1 downto 0);

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: bridge PORT MAP(
		data_rx => data_rx,
		data_tx => data_tx,
		data_mul => data_mul,
		act_uart => act_uart,
		ack_uart => ack_uart,
		send_uart => send_uart,
		rdy_uart => rdy_uart,
		btns => btns,
		valid => valid,
		vys => vys,
		clk => clk,
		rst => rst
	);

	tb : PROCESS
	BEGIN

		-- pocatecni reset
		rst <= '1';
		wait for 10ns;
		rst <= '0';
		
		
		-- Place stimulus here
	
				wait until clk'event and clk = '0';
				--test odeslani dat 12*1= a test vysledku
				--data 1operand
				data_rx <= CONV_STD_LOGIC_VECTOR(character'pos('1'),8);				
				rdy_uart<='1';
				-- cekaqni na potvrzeni prijmuti znaku
				wait until send_uart='1';				
				assert (data_tx = CONV_STD_LOGIC_VECTOR(character'pos('1'),8))report "neodeslana 1ka";
				rdy_uart<='0';
				wait for 10ns;
				--dalsi data
				data_rx <= CONV_STD_LOGIC_VECTOR(character'pos('2'),8);				
				rdy_uart<='1';
				-- cekaqni na potvrzeni prijmuti znaku
				wait until send_uart='1';
				assert (data_tx = CONV_STD_LOGIC_VECTOR(character'pos('2'),8))report "neodeslana 2ka";
				rdy_uart<='0';
				wait for 10ns;
				--data hvezdicka
				data_rx <= CONV_STD_LOGIC_VECTOR(character'pos('*'),8);				
				rdy_uart<='1';
				-- cekaqni na potvrzeni prijmuti znaku
				wait until send_uart='1';
				assert (data_tx = CONV_STD_LOGIC_VECTOR(character'pos('*'),8))report "neodeslana *";
				rdy_uart<='0';
				wait for 10ns;
				--data 2operand
				data_rx <= CONV_STD_LOGIC_VECTOR(character'pos('1'),8);				
				rdy_uart<='1';
				-- cekaqni na potvrzeni prijmuti znaku
				wait until send_uart='1';				
				assert (data_tx = CONV_STD_LOGIC_VECTOR(character'pos('1'),8))report "neodeslana 1ka";
				rdy_uart<='0';
				wait for 10ns;
				--data =
				data_rx <= CONV_STD_LOGIC_VECTOR(character'pos('='),8);				
				rdy_uart<='1';
				-- cekaqni na potvrzeni prijmuti znaku
				wait until send_uart='1';
				assert (data_tx = CONV_STD_LOGIC_VECTOR(character'pos('='),8))report "neodeslano =";
				rdy_uart<='0';
				wait for 10ns;
				wait until btns(0) = '1';
				--test dat pro nasobicku - prvni operand
				assert ( data_mul = "00001100" )report "spatne prijaty 1operand";
				wait until btns(1) = '1';
				--tets dat pro nasobicku - druhy operand
				assert ( data_mul = "00000001")report "spatne prijaty druhy operand";
				wait for 300ns;
				
				--test prevodu cisla na dekadicke
				vys <= "1111111111111111";
				wait for 50ns;
				valid <='1';
				--cekani na odeslani dekadickeho vysledku prevodu cisla 65535
				wait until (send_uart ='1');
				assert (data_tx = CONV_STD_LOGIC_VECTOR(character'pos('6'),8))report "nevysla 6ka";
				wait until (send_uart ='1');
				assert (data_tx = CONV_STD_LOGIC_VECTOR(character'pos('5'),8))report "nevysla 5ka";
				wait until (send_uart ='1');
				assert (data_tx = CONV_STD_LOGIC_VECTOR(character'pos('5'),8))report "nevysla 5ka";
				wait until (send_uart ='1');
				assert (data_tx = CONV_STD_LOGIC_VECTOR(character'pos('3'),8))report "nevysla 3ka";
				wait until (send_uart ='1');
				assert (data_tx = CONV_STD_LOGIC_VECTOR(character'pos('5'),8))report "nevysla 5ka";
				
				wait for 200ns;
				valid <='0';
				wait for 200ns;			

				--neplatna data
				data_rx <= CONV_STD_LOGIC_VECTOR(character'pos('x'),8);				
				rdy_uart<='1';
				-- cekaqni na potvrzeni prijmuti znaku
				wait until ack_uart='1';
				wait for 500ns; --cekani jen aby se znak x poslal vickrat
				rdy_uart<='0';
			
				wait; -- will wait forever
	END PROCESS;
	
	--clock 50MHz
	clock : process
		begin
			clk <= '0';
		wait for 10ns;
			clk <= '1';
		wait for 10ns;
	end process;

END;
