-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : ser_out_tb.vhd
-- Revision : V0.1
-- Author :   Zdenk Sojka
-- Created :  09. 05. 2007
--
-- Modifications
-- 0.1	09. 05. 2007 by Zdenk Sojka
-----------------------------------------------------------------
-- zakladni testbench na vystup seriove linky
--
-- neprovadi automaticke overovani
--
-- 0.1	prvn verze
-----------------------------------------------------------------

LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY ser_out_tb_vhd IS
END ser_out_tb_vhd;

ARCHITECTURE behavior OF ser_out_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT ser_out
	PORT(
		data : IN std_logic_vector(7 downto 0);
		send : IN std_logic;
		clk : IN std_logic;
		rst : IN std_logic;          
		act : OUT std_logic;
		tx : OUT std_logic
		);
	END COMPONENT;

	--Inputs
	SIGNAL send :  std_logic := '0';
	SIGNAL clk :  std_logic := '0';
	SIGNAL rst :  std_logic := '0';
	SIGNAL data :  std_logic_vector(7 downto 0) := (others=>'0');

	--Outputs
	SIGNAL act :  std_logic;
	SIGNAL tx :  std_logic;

BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: ser_out PORT MAP(
		data => data,
		send => send,
		act => act,
		tx => tx,
		clk => clk,
		rst => rst
	);

	hodiny : process
	begin
		clk <= '1';
		wait for 10ns;	-- pro 50 MHz hodiny
		clk <= '0';
		wait for 10ns;
	end process;

	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		rst<='1';
		wait for 100 ns;
		rst<='0';
		
		wait for 40 ns;
		
		data <= "01001100";
		send <= '1';
		wait for 100 ns;
		send <= '0';
		wait for 1100 us;


		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
