-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : mem_ctrl.vhd
-- Revision : V1.0
-- Author :   Zdenk Sojka
-- Created :  21. 04. 2007
--
-- Modifications
-- 2.0	04. 05. 2007 by Zdenk Sojka
-- 1.0	22. 04. 2007 by Zdenk Sojka
-----------------------------------------------------------------
-- pam mikroinstrukc
-- syntetizovan jako ROM
-- v thle form je vce srozumoteln ne jako IP core
--
-- vstupy	: adresa
-- vstupy	: opkd mikroinstrukce
--
-- 2.0	zmna mikrokdu, vpoet a po potvrzen obou operand
--			signl 'load' nahrazen signlem 'valid' pro oznmen platnho vsledku
-- 1.0	prava itelnosti kdu
-----------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity mem_ctrl is
    Port ( Addr : in std_logic_vector(2 downto 0);
           Data : out std_logic_vector(11 downto 0));

end mem_ctrl;

architecture rtl of mem_ctrl is

TYPE t_mem IS array(0 TO 7) OF std_logic_vector(11 DOWNTO 0);

constant cm: t_mem := (
	-- format dat:
	-- naddr(3) vp(2) k2 k1 resV valid shift setB setA

	-- vyber podminky:
	-- 00	bez podminky
	-- 01	zero0 zeroA
	-- 10	btnA
	-- 11	btnB

	-- 000000		-- instrukce pri resetu
	"000100001000",	-- adresa 0, rozskok podle zmacknutych tlacitek, data jsou platna
	-- 000001
	"010110010001",	-- btnA, nacist do A, reset vysledku, neplatna data
	-- 000010
	"010110000000",	-- cekani na btnB
	-- 000011
	"100010000010",	-- btnB, nacist a zacit vypocet

	-- 000100		; cil skoku - posledni dva bity = zero0 zeroA
	--				;		plati implikace zeroA => zero0
	"101000100000",	-- !zero0 & !zeroA - zacit scitani
	-- 000101
	"100011000100",	-- !zero0 & zeroA - nemuze nastat - vyuzito jako druhy krok scitani!
	-- 000110
	"100010000100",	-- zero0 & !zeroA - preskocit tento krok scitani, novy rozskok
	-- 000111
	"000100001000"		-- zero0 & zeroA - nulovy regA, pltny vysledek, zpet na detekci tlacitek
);

begin

Data <= cm(conv_integer(Addr));

end rtl;

