-----------------------------------------------------------------
-- (c) 2007 VUT-FEL, K336
-- http://cs.felk.cvut.cz
-----------------------------------------------------------------
-- Filename : opdekod.vhd
-- Revision : V1.0
-- Author :   Zdenk Sojka
-- Created :  20. 04. 2007
--
-- Modifications
-- 2.0	04. 05. 2007 by Zdenk Sojka
-- 1.0	22. 04. 2007 by Zdenk Sojka
-----------------------------------------------------------------
-- dekodr opkdu mikroinstrukce
--
-- vstupy	: opkd
-- vstupy	: rozdlen opkd na jednotliv signly
--
-- 2.0	signl 'load' nahrazen signlem 'valid'
-- 1.0	prava itelnosti kdu
-----------------------------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity opdekod is
	port (
		op		: in std_logic_vector(11 downto 0);		-- vstup - opkd

		naddr : out std_logic_vector(2 downto 0);	-- adresa dal mikroinstrukce
		vp		: out std_logic_vector(1 downto 0);	-- vbr podmnky
		k2		: out std_logic;							-- krok 2 stn
		k1		: out std_logic;							-- krok 1 stn
		resV	: out std_logic;							-- reset vsledku
		valid	: out std_logic;							-- platna data na vystupu
		shlB	: out std_logic;							-- posun registru B doleva
		shrA	: out std_logic;							-- posun registru A doprava
		setB	: out std_logic;							-- naten registru B od uivatele
		setA	: out std_logic);							-- -//- A
end opdekod;

architecture rtl of opdekod is

begin
	naddr <= op(11 downto 9);
	vp <= op(8 downto 7);
	k2 <= op(6);
	k1 <= op(5);
	resV <= op(4);
	valid <= op(3);
	shlB <= op(2);
	shrA <= op(2);
	setB <= op(1);
	setA <= op(0);
end rtl;

